#include "project.h"
#include "stdio.h"

char str[128] ; /* print buffer */
void print(char *str)
{
    UART_PutString(str) ;
}

#define BIT_DELAY 10 //ms
#define SW_LOW  (0u)
#define SW_HIGH (1u)

#define delay(a)  CyDelayUs(a)

void sw_send_byte(uint8_t byte_to_send)
{
    uint8_t mask = 0x80 ;

    Cy_GPIO_Write(SW_TX_0_PORT, SW_TX_0_NUM, SW_LOW) ; /* start bit wannabe */
    delay(BIT_DELAY) ;
    while(mask) { /* sending 8 bits MSB first */
        if (byte_to_send & mask) {
            Cy_GPIO_Write(SW_TX_0_PORT, SW_TX_0_NUM, SW_HIGH) ;
        } else {
            Cy_GPIO_Write(SW_TX_0_PORT, SW_TX_0_NUM, SW_LOW) ;
        }
        mask >>= 1 ;
        delay(BIT_DELAY) ;
    }
    Cy_GPIO_Write(SW_TX_0_PORT, SW_TX_0_NUM, SW_HIGH) ;    
    delay(BIT_DELAY) ; /* stop bit wannabe */
}

int main(void)
{
    uint8_t byte_to_send = 0x00 ;
    
    __enable_irq(); /* Enable global interrupts. */

    Cy_GPIO_Write(SW_TX_0_PORT, SW_TX_0_NUM, SW_HIGH) ;
    
    CyDelay(1000) ; /* wait for Cortex-M0 to be ready, may be too much */

    for(;;)
    {
        sprintf(str, "CM4 sending 0x%02X\n", byte_to_send) ;
        print(str) ;
        sw_send_byte(byte_to_send) ;
        byte_to_send = (byte_to_send + 1) % 0x100 ;
        CyDelay(1000) ;
    }
}

